import type { PeerId } from '@libp2p/interface-peer-id';
import type { PeerStore, PeerProtocolsChangeData } from '@libp2p/interface-peer-store';
import type { Connection } from '@libp2p/interface-connection';
import type { ConnectionManager } from '@libp2p/interface-connection-manager';
import type { TransportManager } from '@libp2p/interface-transport';
export interface WebRTCSignalConfig {
    enabled: boolean;
    isSignallingNode: boolean;
    autoSignal: AutoSignalConfig;
}
export interface AutoSignalConfig {
    enabled: boolean;
    relayPeerId: string;
}
export interface SignalComponents {
    peerStore: PeerStore;
    connectionManager: ConnectionManager;
    transportManager: TransportManager;
}
export declare class AutoSignal {
    private readonly components;
    private readonly relayPeerId;
    private isListening;
    constructor(components: SignalComponents, init: AutoSignalConfig);
    _onProtocolChange(evt: CustomEvent<PeerProtocolsChangeData>): Promise<void>;
    _onPeerConnected(evt: CustomEvent<Connection>): Promise<void>;
    _onPeerDisconnected(evt: CustomEvent<Connection>): void;
    _handleProtocols(peerId: PeerId, protocols: string[]): Promise<void>;
    /**
     * Attempt to listen on the given connection with relay node
     */
    _addListener(connection: Connection): Promise<void>;
}
//# sourceMappingURL=index.d.ts.map