import { logger } from '@libp2p/logger';
import { EventEmitter, CustomEvent } from '@libp2p/interfaces/events';
const log = logger('libp2p:webrtc-signal');
export class DialResponseListener extends EventEmitter {
    constructor(stream) {
        super();
        this.stream = stream;
    }
    async listen() {
        while (true) {
            try {
                const { done, value } = await this.stream.next();
                if (done !== undefined && done) {
                    break;
                }
                this.dispatchEvent(new CustomEvent('response', { detail: value }));
            }
            catch (err) {
                log.error(err);
                break;
            }
        }
    }
}
//# sourceMappingURL=utils.js.map